<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Perfiles de Usuario</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas agregar un perfil y configurar flujos?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(perfilUsuario, indexPerfilUsuario) in perfilesUsuario"
            :key="indexPerfilUsuario"
            :xs="12"
            :sm="12"
            :md="3"
            :lg="2"
          >
            <v-card class="generalCard pa-4">
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ perfilUsuario.perfil.descripcion }}
                </div>
                <v-footer class="CardCustomAction">
                  <v-col>
                    <v-btn
                      :to="perfilUsuario.to_flujos_perfil"
                      class="ma-2"
                      dark
                      tile
                      depressed
                      color="primary"
                      >Configurar Flujos</v-btn
                    >
                  </v-col>
                </v-footer>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddPerfil.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddPerfil.to"
            :color="cardAddPerfil.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddPerfil.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddPerfil.src"
                :lazy-src="cardAddPerfil.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este perfil?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingPerfil }]"
                  @click="deletePerfil()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-PerfilesFlujoUsuario",
  data() {
    return {
      moment: moment,
      perfil_delete: null,
      dialogDelete: false,
      deletingPerfil: false,
      usuario: null,
      cardAddPerfil: {
        title: "Asociar Perfil Personalizado",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo perfil a la lista.",
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Usuarios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_usuario"
          }
        }
      ],
      perfilesUsuario: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    initValues() {
      this.breadcrumbs.push({
        text: this.serviceCommons.titleCase(this.usuario.nombre_usuario),
        disabled: true
      });
      this.breadcrumbs.push({
        text: "Perfiles",
        disabled: true
      });
      this.cardAddPerfil.to = {
        name: "privilegios_usuario_perfiles_personalizados",
        params: {
          usuario: this.serviceCommons.objectToBase64(this.usuario)
        }
      };
    },
    getPerfilesUsuario() {
      var self = this;
      axios
        .get("/usuario/secure/get/perfiles/" + this.usuario.id_usuario)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              let data = response.data.data.perfiles;
              data = JSON.parse(JSON.stringify(data));
              self.setPerfilesUsuario(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfilesUsuario(data) {
      if (data) {
        data.forEach((itemPerfil) => {
          itemPerfil.to_flujos_perfil = {
            name: "privilegios_usuario_flujos_perfil",
            params: {
              perfil: this.serviceCommons.objectToBase64(itemPerfil.perfil),
              usuario: this.serviceCommons.objectToBase64(this.usuario)
            }
          };
        });
        this.perfilesUsuario = data;
      }
    },
    deletePerfil() {
      var self = this;
      self.perfil_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/perfil/secure/delete", { data: self.perfil_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getPerfiles();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingPerfil = false;
        });
    }
  },
  created() {
    if (this.$route.params.usuario) {
      this.usuario = this.serviceCommons.base64ToObject(
        this.$route.params.usuario
      );
    }
    this.initValues();
    this.getPerfilesUsuario();
  }
};
</script>
